/* 
   $Id: IMProto.h,v 1.3 2001/06/13 06:54:43 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef NNM_IMPROTO_H
#define NNM_IMPROTO_H

#define XIM_CONNECT			  1
#define XIM_CONNECT_REPLY		  2
#define XIM_DISCONNECT			  3
#define XIM_DISCONNECT_REPLY		  4

#define XIM_AUTH_REQUIRED		 10
#define XIM_AUTH_REPLY			 11 
#define XIM_AUTH_NEXT			 12
#define XIM_AUTH_SETUP			 13
#define XIM_AUTH_NG			 14

#define	XIM_ERROR			 20

#define XIM_OPEN			 30
#define XIM_OPEN_REPLY			 31
#define XIM_CLOSE			 32
#define XIM_CLOSE_REPLY			 33
#define XIM_REGISTER_TRIGGERKEYS	 34
#define	XIM_TRIGGER_NOTIFY		 35
#define XIM_TRIGGER_NOTIFY_REPLY	 36
#define XIM_SET_EVENT_MASK		 37
#define XIM_ENCODING_NEGOTIATION	 38
#define XIM_ENCODING_NEGOTIATION_REPLY	 39
#define XIM_QUERY_EXTENSION		 40
#define XIM_QUERY_EXTENSION_REPLY	 41
#define XIM_SET_IM_VALUES		 42
#define XIM_SET_IM_VALUES_REPLY		 43
#define XIM_GET_IM_VALUES		 44
#define XIM_GET_IM_VALUES_REPLY		 45

#define XIM_CREATE_IC			 50
#define XIM_CREATE_IC_REPLY		 51
#define XIM_DESTROY_IC			 52
#define XIM_DESTROY_IC_REPLY		 53
#define XIM_SET_IC_VALUES		 54
#define XIM_SET_IC_VALUES_REPLY		 55
#define XIM_GET_IC_VALUES		 56
#define XIM_GET_IC_VALUES_REPLY		 57
#define XIM_SET_IC_FOCUS		 58
#define XIM_UNSET_IC_FOCUS		 59
#define XIM_FORWARD_EVENT		 60
#define XIM_SYNC			 61
#define XIM_SYNC_REPLY			 62
#define XIM_COMMIT			 63
#define XIM_RESET_IC			 64
#define XIM_RESET_IC_REPLY		 65

#define XIM_GEOMETRY			 70
#define XIM_STR_CONVERSION		 71
#define XIM_STR_CONVERSION_REPLY	 72
#define XIM_PREEDIT_START		 73
#define XIM_PREEDIT_START_REPLY		 74
#define XIM_PREEDIT_DRAW		 75
#define XIM_PREEDIT_CARET		 76
#define XIM_PREEDIT_CARET_REPLY		 77
#define XIM_PREEDIT_DONE		 78
#define XIM_STATUS_START		 79
#define XIM_STATUS_DRAW			 80
#define XIM_STATUS_DONE			 81
#define XIM_PREEDITSTATE		 82

#define	PADDING(x)	((4-((x)%4))%4)

typedef struct _XIMSTRING{
  int		len;	// length of string in byte
  unsigned char	*ptr;	// string ; LISTofLPCE
} XIMSTRING;

typedef struct _XIMSTR{
  int		len;	// length of name in byte
  unsigned char	*ptr;	// name ; LISTofLPCE
} XIMSTR;

typedef struct _XIMATTR {
  int		ID;		// Attribute ID
  int		TypeOfValue;	// type of the value
  int		len;		// length of im-attribute
  unsigned char	*ptr;		// im-atribute
} XIMATTR;

typedef struct _XICATTR {
  int		ID;		// Attribute ID
  int		TypeOfValue;	// type of the value
  int		len;		// length of im-attribute
  unsigned char	*ptr;		// im-atribute
} XICATTR;

typedef struct _XIMTRIGGERKEY{
  unsigned long	keysym;
  unsigned long	modifier;
  unsigned long	modifier_mask;
} XIMTRIGGERKEY;

typedef struct _XIMENCODINGINFO{
  int		len;	// length of encoding info
  unsigned char	*ptr;	// encoding info
} XIMENCODINGINFO;

typedef struct _XIMEXT{
  int	major_opcode;
  int	minor_opcode;
  int	length;
  char	*ptr;
} XIMEXT;

typedef struct _XIMATTRIBUTE{
  int		attrID;	// attribute ID
  int		len;	// length of value
  unsigned char	*ptr;	// value
} XIMATTRIBUTE;

typedef struct _XICATTRIBUTE{
  int		attrID;	// attribute ID
  int		len;	// length of value
  unsigned char	*ptr;	// value
} XICATTRIBUTE;

typedef struct _XIMRectangle{
  int		X, Y;
  int		width, height;
} XIMRectangle;

typedef struct _XIMPoint{
  int		X, Y;
} XIMPoint;

typedef struct _XIMFontSet{
  int		len;
  char		*base_name;
} XIMFontSet;

typedef struct _XIMSTRCONVTEXT{
  int		feedback;
  int		len_str;
  unsigned char	*str;
  int		len_array;
  unsigned char	*array;
} XIMSTRCONVTEXT;

#define XIMERR_IMIDMASK 1
#define XIMERR_ICIDMASK 2

#define XIMERR_BADALLOC 1
#define XIMERR_BADSTYLE 2
#define XIMERR_BADCLIENTWINDOW 3
#define XIMERR_BADFOCUSWINDOW 4
#define XIMERR_BADAREA 5
#define XIMERR_BADSPOTLOCATION 6
#define XIMERR_BADCOLORMAP 7
#define XIMERR_BADATOM 8
#define XIMERR_BADPIXEL 9
#define XIMERR_BADPIXMAP 10
#define XIMERR_BADNAME 11
#define XIMERR_BADCURSOR 12
#define XIMERR_BADPROTOCOL 13
#define XIMERR_BADFOREGROUND 14
#define XIMERR_BADBACKGROUND 15
#define XIMERR_LOCALENOTSUPPORTED 16
#define XIMERR_BADSOMETHING 999

typedef struct _XIMERROR{
  int		imID;
  int		icID;
  int		flag;
  int		err_code;
  int		len;
  int		type;
  unsigned char	*detail;
} XIMERROR;

/* Type Of Value for XIMATTR and XICATTR */
#define TOV_Separator		0
#define TOV_bytedata		1
#define TOV_worddata		2
#define TOV_longdata		3
#define TOV_chardata		4
#define TOV_Window		5
#define TOV_XIMStyles		10
#define TOV_XRectangle		11
#define TOV_XPoint		12
#define TOV_XFontSet		13
#define TOV_XIMHotKeyTriggers	15
#define TOV_XIMHotKeyState	16
#define TOV_XIMStringConversion	17
#define TOV_XIMPreeditState	18
#define TOV_XIMResetState	19
#define TOV_NestedList		0x7fff

typedef struct im_connection_struct{
  int		use;
  Window	client;
  Widget	server;
} ImConnectionRec;

typedef struct _ic_struct{
  int		use;
  int		imID;
  XICATTR	xicattr[20];
} XIC_Rec;

#endif // IMPROTO_H



